<!DOCTYPE html>
<html lang="en">
<head>
    <title>Task 44.50 - hienltt</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<style>
    .picture-cover{
        background-image: url("LuckyDiceImages/cover.jpg");
        min-height: 100px;
        margin: 5px;
   }
</style>
<body>
    <div class="container-fluid picture-cover">
    </div>
    <div class="container">
        <div class="row ">                
            <div  class="col-5">
                <div class="row form-group">
                    <div class="col-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>Username</label>
                    </div>
                    <div class="col-8">
                        <input id="inp-user-name" class="form-control" type="text" required>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>Firstname</label>
                </div>
                <div class="col-8">
                    <input id="inp-first-name" class="form-control" type="text" required>
                </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>Lastname</label>
                </div>
                <div class="col-8">
                    <input id="inp-last-name" class="form-control" type="text" required>
                </div>
                </div>
            </div>
        
            <div class="col-4 text-center">
                <div class="row form-group">
                    <div class="col-12">
                        <button id="btn-dice" class="btn btn-success button-width w-75">Ném</button>
                    </div>
            </div>
            <div class="row form-group">
                    <div class="col-12">
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div> 
            </div>
            <div class="col-3 text-center">
                <div class="row form-group">
                    <div class="col-12">
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/xe-may.jpg">
                    </div> 
                </div>
            </div>
        </div>
        <div class="row text-center form-group">
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>                  
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover border">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>    
</body>
<script>
    "use strict";
    $(document).ready(function(){
    //**** REGION 1: Global_variables Vùng khai báo biến, hằng số, tham số TOÀN CỤC
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const vBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
    const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";

    var gElementUserName = $('#inp-user-name');
    var gElementFirstName = $('#inp-first-name');
    var gElementLastName = $('#inp-last-name');
    //**** REGION 2: Vùng gán/thực thi sự kiện cho các elements
    // gán sự kiện cho nút ném
    $("#btn-dice").on("click",function(){
            onBtnNemClick();
    })
    // REGION 3: Event handlers-Vùng khai báo các hàm xử lý sự kiện*/
    //hàm gọi khí nhấn nút ném
    function onBtnNemClick(){
        "use strict";
        // Tạo đối tượng để truyền dữ liệu giữa các bước
        var vUserObj = {
            username: "",
            firstname: "",
            lastname: ""
        };
        // Bước 1: thu thập dữ liệu
        getData(vUserObj);
        // Bước 2:kiểm tra dữ liệu
        var vCheck = validateData(vUserObj);
        console.log(vCheck);
        if(vCheck){
            // Bước3:gọi API server
            var vXmlHttpDice = new XMLHttpRequest();
            callApiServerDice(vXmlHttpDice, vUserObj);
            vXmlHttpDice.onreadystatechange = function(){
                if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){// nếu trạng thái của response ready và ok
                    // Bước4:xử lý response trả về từ server
                    processReponse(vXmlHttpDice);
                }
            }
        }

        
    }
    // REGION 4: Vùng khai báo các hàm sử dụng chung
    // hàm thu thập dữ liệu
    function getData(paraDataUser){
        "use strict";
        paraDataUser.username = gElementUserName.val().trim();
        paraDataUser.firstname = gElementFirstName.val().trim();
        paraDataUser.lastname = gElementLastName.val().trim();
    }
    // Hàm kiểm dữ liệu 
    function validateData(paraDataUser){
        "use strict";
        var vResult = true;

        if(paraDataUser.username == ""){
            alert("Hãy nhập username");
            vResult = false;
        }
        else if(paraDataUser.firstname == ""){
            alert("Hãy nhập firstname");
            vResult = false;
        }
        else if(paraDataUser.lastname == ""){
            alert("Hãy nhập lastname");
            vResult = false;
        }
        return vResult;
    }
    // hàm gọi api
    function callApiServerDice(paramXmlHttpDice, paramDataUser){
        "use strict";
        paramXmlHttpDice.open("POST", vBASE_URL + "/dice", true);
        paramXmlHttpDice.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttpDice.send(JSON.stringify(paramDataUser));// chuyen Json object sang string
    }
    // hàm xử lý response trả về thành công
    function processReponse(paramXmlHttpDice){
        "use strict";                                
        console.log(paramXmlHttpDice.responseText);
        // parsing JSON to object
        var vResponseToObject = JSON.parse(paramXmlHttpDice.responseText);
        console.log(vResponseToObject);
        // get result dice
        var vNumberOfDice = vResponseToObject.dice;
        console.log("Số xúc xắc = " + vNumberOfDice);
        // gọi hàm hiển thị dice
        changeImgDiceByNumberDice(vNumberOfDice);
        // gọi hàm hiện thị lời nhắn
        changeMessage(vNumberOfDice);
        // gọi hàm hiển thị voucher
        displayVoucher(vResponseToObject);
        // gọi hàm hiến ảnh phần thưởng
        displayGift(vResponseToObject);
    }
    // hàm hiển thị dice
    function changeImgDiceByNumberDice(paramDice){
        "use strict";
        var vImgDice = $('#img-dice');
        switch(paramDice){
            case 1:
                vImgDice.attr('src', 'LuckyDiceImages/1.png');
                break;
            case 2:
                vImgDice.attr('src', 'LuckyDiceImages/2.png');
                break;
            case 3:
                vImgDice.attr('src', 'LuckyDiceImages/3.png');
                break;
            case 4:
                vImgDice.attr('src', 'LuckyDiceImages/4.png');
                break;
            case 5:
                vImgDice.attr('src', 'LuckyDiceImages/5.png');
                break;
            default:
                vImgDice.attr('src', 'LuckyDiceImages/6.png');
        }
    }
    // hàm hiển thị lời nhắn
    function changeMessage(paramDice){
        "use strict";
        var vMessage = $('#p-notification-dice');
        if(paramDice < 4){
            vMessage.removeClass().addClass('text-primary').html("Chúc bạn may mắn lần sau !!!");
        }
        else{
            vMessage.removeClass().addClass('text-danger').html("Chúc mừng bạn hãy chơi tiếp lần nữa !!!");
        }
    }
    // hàm hiển thị voucher
    function displayVoucher(paramResponeVoucher){
        "use strict";
        var vPVoucherId = $("#p-voucher-id");
        var vPVoucherPercent = $("#p-voucher-percent");
        if(paramResponeVoucher.voucher != null){
            vPVoucherId.html(paramResponeVoucher.voucher.maVoucher);
            vPVoucherPercent.html(paramResponeVoucher.voucher.phanTramGiamGia + "%");
        }
        else{
            vPVoucherId.html("");
            vPVoucherPercent.html("");
        }
    }
    // hàm hiển thị ảnh phần thưởng
    function displayGift(paramResponePrize){
        var vImgPresent = $("#img-present");
        var vTenPhanThuong = paramResponePrize.prize;
        switch(vTenPhanThuong){
            case "Mũ":
                vImgPresent.attr('src', 'LuckyDiceImages/hat.jpg');
                break;
            case "Áo":
                vImgPresent.attr('src', 'LuckyDiceImages/t-shirt.jpg');
                break;
            case "Xe máy":
                vImgPresent.attr('src', 'LuckyDiceImages/xe-may.jpg');
                break;
            case "Ôtô":
                vImgPresent.attr('src', 'LuckyDiceImages/car.jpg');
                break;
            default:
                vImgPresent.attr('src', 'LuckyDiceImages/no-present.jpg');
        }
    }
})
</script>
</html>